from os.path import dirname, join
from logging import getLogger
import sys


try:
    import plone.keyring
    import plone.protect
except ImportError:
    import plone.app
    pkgs = ('plone.keyring-hotfix-py2.4.egg', 'plone'), \
           ('plone.protect-hotfix-py2.4.egg', 'plone')
    for egg, ns in pkgs:
        path = join(dirname(__file__), egg)
        sys.path.append(path)               # add package path
        module = sys.modules.get(ns)
        assert isinstance(module.__path__, list)
        sub = join(path, *ns.split('.'))
        module.__path__.append(sub)         # adjust namespace package path
    import plone.keyring
    import plone.protect


def setup():
    from Products.CMFCore.DirectoryView import registerDirectory
    registerDirectory('skins', globals())

    from Products.PloneHotfixCVE20080164.csrf import applyPatches
    applyPatches()

    from Products.PloneHotfixCVE20080164.browser import patchViews
    patchViews()


def initialize(context):
    try:
        from Products.CMFPlone.patches import csrf
        getLogger(__name__).info('CSRF protection already in place, aborting.')
    except ImportError:
        setup()
        getLogger(__name__).info('CSRF hotfix applied.')

